package CAFI;

/**
Agent.java 

A class that can be root class for agents of all kinds, spatial and aspatial.

**/

import java.util.Formatter;
import java.awt.Point;
import java.util.ArrayList;

import uchicago.src.sim.util.*;
import uchicago.src.sim.gui.*;
import uchicago.src.sim.gui.ColorMap;

public class Agent {
	// "class" variables -- one value for all instances 
    public  static int          	nextId = 0; // to give each a unique id
	public  static Model		   	model;      // the model "in charge"
	public  static GridWorld	   	world;  	// where (some) agents live

	// fields (instance variables)  
	int 				id;		// unique id number for each instance
	public boolean		live;		// is it live or dead


	// a constructor
	public Agent ( ) {
		id = nextId++;
		live = true;
	}


	////////////////////////////////////////////////////////////////////////////
	// step
	// Top level definition of what the agent can do each time its activiated.

	public void step () {

		if ( model.getRDebug() > 0 ) 
			System.err.printf( "   -->Agent-step() for id=%d.\n", id );








		if ( model.getRDebug() > 1 ) 
			System.err.printf("   <--Agent-step() done.\n" );

	}


	////////////////////////////////////////////////////////////
	// printOut
	// print fields to System.out.
	//
	// Note: we can use the class's field variables in all methods.

	public void printOut ( ) {
		System.out.printf( " - Agent id %2d; live=%b).\n",
						   id, live );
	}

	////////////////////////////////////////////////////////////////////////////
	// setters and getters
	//
	public int getId() {  return id; }

	public boolean getLive() { return live; }
	public void setLive( boolean l ) { live = l; }

	// note these are class (static) methods, to set class (static) variables
	public static void setWorld( GridWorld w ) {	world = w; }
	public static void setModel( Model m ) { model = m; }
	public static void setNextId ( int i ) { nextId = i; }

}
