package CAFI;

import java.awt.Point;
import java.util.ArrayList;

import uchicago.src.sim.analysis.Plot;
import uchicago.src.sim.space.Object2DGrid;
import uchicago.src.sim.util.SimUtilities;

public class Ecosystem {
	
	public static int				nextID = 0;
	public int						ID;
	public  static Model	   		model;      // the model "in charge"
	public static GridWorld				world;
    public int						sizeX;
    public int						sizeY;
 
    
    public ArrayList<Tree> 			speciesList = new ArrayList<Tree> ();  // holds addresses of ants in the world
    public static ArrayList<Object>	objectList = new ArrayList<Object> (); // holds list of all objects in the space
    
    // plotting variables
    
    //just keeping these here for now so i remember where plot variables should go
    //public Plot				foodPilesGraph;
    //public static Plot		bugsOverTimeGraph;
    //public static Plot		deathsOverTimeGraph;
    
    //Constructors
    public Ecosystem () {
    	
    	ID = nextID++;
    	sizeX = model.getSizeX();
    	sizeY = model.getSizeY();
    	speciesList = new ArrayList<Tree> ();

    }
    
    //Methods
    
    //MAKING AN ECOSYSTEM
    public void addSpecies (double maxDensity, int speciesNum) {
    	
    	
    	Tree newTree = new Tree(maxDensity, speciesNum);
    	speciesList.add(newTree);
		
    }
    

    ///////////////////////////////////////////////////////////////////////
    //Getters and Setters

    public int getID() { return ID; }
    public void setID(int i) { ID = i; }
    
    /*public void setFoodPilesGraph(Plot PilesGraph)  { foodPilesGraph = PilesGraph; }
    public static void setBugsOverTimeGraph(Plot TimeGraph)  { bugsOverTimeGraph = TimeGraph; }
    public static void setDeathsOverTimeGraph(Plot TimeGraph)  { deathsOverTimeGraph = TimeGraph; }*/
    
    public Object2DGrid getTree ( int number) { return speciesList.get(number).volume; }
	public void setTree ( Object2DGrid tree, int number ) { 
		this.speciesList.get(number).volume = tree;
	}
    
    
	// note these are class (static) methods, to set class (static) variables
	public static void setWorld( GridWorld w ) {	world = w; }
	public static void setModel( Model m ) { model = m; }
	//public static void setNextId ( int i ) { nextId = i; }
}
