package CAFI;

/**
NewRoadObs.java 

A class that can be root class for observations of all kinds.

**/

import java.util.Formatter;
import java.awt.Point;
import java.util.ArrayList;

import uchicago.src.sim.util.*;
import uchicago.src.sim.gui.*;
import uchicago.src.sim.gui.ColorMap;

public class NewRoadObs {
	// "class" variables -- one value for all instances 
    public  static int          	nextId = 0; // to give each a unique id
	public  static Model		   	model;      // the model "in charge"
	public  static GridWorld	   	world;  	// where (some) agents live

	// fields (instance variables)  
	int 				id;		// unique id number for each instance
	int					x;
	int					y;
	double 				potentialValue;
	double				volume;
	double 				volumeSp1;
	double				volumeSp2;
	double				netReturnSp1M3;
	double				maxReturnM3;
	double 				maxAccess;
	double				currentMaintAlongRoad;
	int					elementID;
	int 				source;
	
	


	// a constructor 
	
	//for now, let the observation include all observable variables
	public NewRoadObs (int newX, int newY, int s, double pV, double dAR, double v, double v1, double v2, double nRSp1, double mR, double mA) {
		id = nextId++;
		x = newX;
		y = newY;
		potentialValue = pV;
		currentMaintAlongRoad = dAR;
		elementID = (y)*model.sizeX + x;
		volume = v;
		volumeSp1 = v1;
		volumeSp2 = v2;
		netReturnSp1M3 = nRSp1;
		maxReturnM3 = mR;
		maxAccess = mA;
		source = s;
	}

	
	public void updateObservation (double pV) {

		potentialValue = pV;
	}

	
	////////////////////////////////////////////////////////////
	// printOut
	// print fields to System.out.
	//
	// Note: we can use the class's field variables in all methods.

	public void printOut ( ) {
		System.out.printf( " - Agent id %2d).\n",
						   id );
	}

	////////////////////////////////////////////////////////////////////////////
	// setters and getters
	//
	public int getId() {  return id; }

	public int getX() { return x; }
	public void setX( int l ) { x = l; }
	public int getY() { return y; }
	public void setY( int l ) { y = l; }

	// note these are class (static) methods, to set class (static) variables
	public static void setWorld( GridWorld w ) {	world = w; }
	public static void setModel( Model m ) { model = m; }
	public static void setNextId ( int i ) { nextId = i; }

}
