package CAFI;

/**
Report.java 

A class that can be root class for reports of all kinds.

**/

import java.util.Formatter;
import java.awt.Point;
import java.util.ArrayList;

import uchicago.src.sim.util.*;
import uchicago.src.sim.gui.*;
import uchicago.src.sim.gui.ColorMap;

public class Report {
	// "class" variables -- one value for all instances 
    public  static int          	nextId = 0; // to give each a unique id
	// where (some) agents live

	// fields (instance variables)  
	int 				id;		// unique id number for each instance
	int					x;
	int					y;
	double				massLoggedIllegally;

	
	


	// a constructor 
	
	//for now, let the observation include all observable variables
	public Report (int newX, int newY, double extent ) {
		id = nextId++;
		x = newX;
		y = newY;
		massLoggedIllegally = extent;

	}

	

	
	////////////////////////////////////////////////////////////
	// printOut
	// print fields to System.out.
	//
	// Note: we can use the class's field variables in all methods.

	public void printOut ( ) {
		System.out.printf( " - Agent id %2d).\n",
						   id );
	}

	////////////////////////////////////////////////////////////////////////////
	// setters and getters
	//
	public int getId() {  return id; }

	public int getX() { return x; }
	public void setX( int l ) { x = l; }
	public int getY() { return y; }
	public void setY( int l ) { y = l; }
	public double getMassLoggedIllegally() { return massLoggedIllegally; }
	public void setMassLoggedIllegally( int l ) { massLoggedIllegally = l; }

	// note these are class (static) methods, to set class (static) variables
	public static void setNextId ( int i ) { nextId = i; }

}
